package provide moodsshelp 1.0
set htmlHelpContents {
<html><body>
<ul>
  <li><a href="#about">1. About this document</a>
  <li><a href="#introduction">2. Introduction</a>
  <li><a href="#required">3. Installation</a>
  <li><a href="#architecture">4. Architecture</a>
  <li><a href="#userinterface">5. User interface</a><ul>
    <li><a href="#tables">5.1. Tables</a>
    <li><a href="#viewers">5.2. Viewers</a><ul>
      <li><a href="#viewers.graphs">5.2.1. Graphs</a>
      <li><a href="#viewers.bars">5.2.2. Bars</a>
      <li><a href="#viewers.pies">5.2.3. Pies</a>
      <li><a href="#viewers.tables">5.2.4. Tables</a>
      <li><a href="#viewers.text">5.2.5. Text</a>
      <li><a href="#viewers.examples">5.2.5. Examples</a>
    </ul>
    <li><a href="#titlebar">5.3. Title bar</a>
    <li><a href="#menus">5.4. Menu bar</a><ul>
      <li><a href="#menus.file">5.4.1. File</a><ul>
        <li><a href="#menus.file.new">5.4.1.1. New</a>
        <li><a href="#menus.file.open">5.4.1.2. Open</a>
        <li><a href="#menus.file.save">5.4.1.3. Save</a>
        <li><a href="#menus.file.saveas">5.4.1.4. Save as</a>
        <li><a href="#menus.file.modules">5.4.1.5. Modules</a><ul>
          <li><a href="#menus.file.modules.load">5.4.1.5.1. Load</a>
          <li><a href="#menus.file.modules.manage">5.4.1.5.2. Manage</a>
          <li><a href="#menus.file.modules.loaded">5.4.1.5.3. Loaded</a>
        </ul>
        <li><a href="#menus.file.database">5.4.1.6. Database</a><ul>
          <li><a href="#menus.file.database.load">5.4.1.6.1. Load</a>
          <li><a href="#menus.file.database.start">5.4.1.6.2. Start</a>
          <li><a href="#menus.file.database.stop">5.4.1.6.3. Stop</a>
        </ul>
        <li><a href="#menus.file.print">5.4.1.7. Print</a>
        <li><a href="#menus.file.exit">5.4.1.8. Exit</a>
      </ul>
      <li><a href="#menus.edit">5.4.2. Edit</a><ul>
        <li><a href="#menus.edit.thresholds">5.4.2.1. Thresholds</a><ul>
          <li><a href="#menus.edit.thresholds.types">5.4.2.1.1. Types</a>
          <li><a href="#menus.edit.thresholds.color">5.4.2.1.2. Color</a>
          <li><a href="#menus.edit.thresholds.script">5.4.2.1.3. Script</a>
          <li><a href="#menus.edit.thresholds.dragging">5.4.2.1.4. Dragging</a>
          <li><a href="#menus.edit.thresholds.notes">5.4.2.1.5. Notes</a>
        </ul>
        <li><a href="#menus.edit.configuration">5.4.2.2. Configuration</a>
        <li><a href="#menus.edit.newpage">5.4.2.3. New page</a>
        <li><a href="#menus.edit.newviewer">5.4.2.4. New viewer</a>
        <li><a href="#menus.edit.database">5.4.2.5. Database</a>
        <li><a href="#menus.edit.preferences">5.4.2.6. Preferences</a>
      </ul>
      <li><a href="#menus.view">5.4.3. View</a><ul>
        <li><a href="#menus.view.refresh">5.4.3.1. Refresh</a>
        <li><a href="#menus.view.polltime">5.4.3.2. Poll Time</a>
        <li><a href="#menus.view.database.range">5.4.3.3. Database range</a>
        <li><a href="#menus.view.trace">5.4.3.4. Trace</a>
        <li><a href="#menus.view.toolbar">5.4.3.5. Tool bar</a>
      </ul>
      <li><a href="#menus.help">5.4.4. Help</a><ul>
        <li><a href="#menus.help.global">5.4.4.1. Global</a>
        <li><a href="#menus.help.modules">5.4.4.2. Modules</a>
        <li><a href="#menus.help.about">5.4.4.3. About</a>
      </ul>
    </ul>
    <li><a href="#toolbar">5.5. Tool bar</a>
    <li><a href="#canvasarea">5.6. Canvas area</a>
    <li><a href="#pagetabs">5.7. Page tabs</a>
    <li><a href="#message">5.8. Message</a>
    <li><a href="#messagesarea">5.9. Messages area</a>
    <li><a href="#draganddrop">5.10. Drag and drop</a><ul>
      <li><a href="#dropsites">5.10.1. Drop sites</a>
      <li><a href="#dragsites">5.10.2. Drag sites</a>
    </ul>
  </ul>
  <li><a href="#commandline">6. Command line</a><ul>
    <li><a href="#mainarguments">6.1. Main arguments</a>
    <li><a href="#modulearguments">6.2. Module arguments</a>
  </ul>
  <li><a href="#core.configuration">7. Configuration</a><ul>
    <li><a href="#configuration.application">7.1. Application</a><ul>
      <li><a href="#configuration.application.size">7.1.1. Size</a>
      <li><a href="#configuration.application.colors">7.1.2. Colors</a>
    </ul>
    <li><a href="#configuration.viewers">7.2. Viewers</a><ul>
      <li><a href="#configuration.viewers.colors">7.2.1. Colors</a>
      <li><a href="#configuration.viewers.graphs">7.2.2. Graphs</a>
      <li><a href="#configuration.viewers.pies">7.2.3. Pies</a>
      <li><a href="#configuration.viewers.tables">7.2.4. Tables</a>
      <li><a href="#configuration.viewers.cells">7.2.5. Cells</a>
    </ul>
  </ul>
  <li><a href="#core.preferences">8. Preferences</a><ul>
    <li><a href="#preferences.application">8.1. Application</a><ul>
      <li><a href="#preferences.application.fonts">8.1.1. Fonts</a>
      <li><a href="#preferences.application.printing">8.1.2. Printing</a>
      <li><a href="#preferences.application.pages">8.1.3. Pages</a>
      <li><a href="#preferences.application.database">8.1.4. Database</a>
      <li><a href="#preferences.application.trace">8.1.5. Trace</a>
    </ul>
    <li><a href="#preferences.thresholds">8.2. Thresholds</a><ul>
      <li><a href="#preferences.thresholds.email">8.2.1. Email</a>
      <li><a href="#preferences.thresholds.trace">8.2.2. Trace</a>
    </ul>
    <li><a href="#preferences.moomps">8.3. Daemon (moomps)</a>
  </ul>
  <li><a href="#faq">9. Frequently Asked Questions</a>
  <li><a href="#future">10. Future developments</a>
  <li><a href="#misc">11. Miscellaneous information</a>
</ul>
</body></html>}
set htmlHelpData {
<body><html>

<h3><a name="about"></a>1. About this document</h3>

This document contains general information, reference information and examples designed to help the user understand the moodss application and the programmer write modules for it.

<h3><a name="introduction"></a>2. Introduction</h3>

Quite often, one needs to monitor changing data, whether it comes from a system, such as the different processes running on a UNIX server, or from a network, such as the volume and distribution of traffic that runs through it.

<p>Most often, such data can be organized in a table with rows of information, each column representing a different kind of data. For example, in the case of processes running on a computer system, rows might be sorted according to their unique process identifier, with columns containing values such as CPU usage, memory usage, owner's name, time of creation, ...

<p>The software used to view this type of information comes in different forms and shapes. UNIX users might be familiar with the <i>top</i> application which presents rows of process data as lines of text, whereas RMON (Remote MONitoring) SNMP software usually uses multiple windows with graphical displays, curves, pie charts, multiple configuration dialog boxes, even 3D visualization modules to visualize network traffic, connection matrices, ...

<p>In most cases, data comes from one or more tables. A common interface, graphical with menus, drag'n'drop capability, table widgets, textual and graphical data viewers such as multiple line graphs, bar and pie charts, could be used. The user could then sort table rows, select one or more cells, rows, columns, create views such as other tables, charts, ... best suited to the way data should be presented. Once optimized, the data viewers layout and configuration could be saved for later reuse as a dashboard. In effect, what is needed is a spreadsheet tailored to dynamic data processing.

<p>Moodss (Modular Object Oriented Dynamic SpreadSheet) is an attempt at filling these needs. It is composed of a main part (the core) and an unlimited number of modules, loaded as the application is launched or while it is running, each module interfacing to a specific type of data. The core is written in the Tcl language (at <a href="http://www.tcl.tk/">http://www.tcl.tk/</a>) using object oriented techniques thanks to the stooop package (at <a href="http://jfontain.free.fr/">http://jfontain.free.fr/</a>). The module function is to describe the data that it is also in charge of retrieving and formatting. Modules can be written in a scripting language (Tcl, Perl or Python) or use dynamically linked libraries written in the C language (modules are packages in the Tcl sense, so any language that can interface with Tcl is supported).

<p><b>Main features</b>:<ul>
  <li>modular architecture: any number of modules can be concurrently loaded to monitor any sort of data (<i>system</i>, <i>database</i> (<i>MySQL</i>), <i>network</i>, <i>hardware</i>, ...) 
  <li>user friendly graphical interface with full drag'n'drop functionality and complete context sensitive help
  <li>powerful threshold functionality: no limits on the number of thresholds, email alerts with screen shots and multiple SMTP servers, user script launching, importance level compatible with the UNIX syslog facility
  <li>very flexible display organization with unlimited number of notebook type pages
  <li>dashboards can be constructed from any number of modules, with graphical viewers (<i>graphs</i>, <i>bar charts</i>, <i>pies</i>, ...) and thresholds easily created by drag'n'drop, all saved in a loadable file
  <li>specific modules can easily be developed using a scripting language (<i>Tcl</i>, <i>Perl</i> or <i>Python</i>) or in <i>C</i>
  <li>saved dashboards are fully compatible with the associated <i>moomps</i> daemon for background monitoring
  <li>any number of data cells histories over time can be stored in a SQL database
  <li>multiple platforms support: all <i>UNIX</i>, <i>Linux</i>, <i>BSD</i> based machines and <i>Windows</i>
  <li>threshold alerts forwarded by email to one or more administrators
  <li>modules for the <i>MySQL</i> database server feature:<ul>
    <li>monitor as many servers (such as replicated) as you wish, on the same dashboard
    <li>native connection to the database servers or via <i>ODBC</i>
    <li>performance, statistics and errors monitoring
    <li>monitor servers residing on any <i>MySQL</i> supported platforms (<i>UNIX</i>, <i>Windows</i>, ...) can be combined with host system monitoring (<i>cpustats</i>, <i>memstats</i>, <i>mounts</i>, ...), network monitoring (<i>snmp</i>, <i>snmptrap</i>, ...) and web server monitoring (<i>apache</i>, <i>apachex</i>, ...) to construct a site wide monitoring station
  </ul>
</ul>

<p>Modules are loaded when moodss is started or dynamically at a later time. Several modules can be handled concurrently. This way, you may monitor data coming from any number of heterogeneous sources. Modules are specified in the command line or dynamically loaded, and can be unloaded at any time.

<p>Since module data access is entirely customizable (through C code, Perl, Python, Tcl, HTTP, ...) and since several modules can be loaded at once, applications for moodss become limitless. For example, comparing a remote database server CPU activity and traffic load from a network probe on the same graph becomes possible.

<p>As features are added to moodss, different ways of viewing data will be made available while the module structure will stay the same. The goal of moodss is to become a nice feature packed generic way of monitoring any device. Moodss can be used to monitor any type of data, since the simplest cases can fit in one table with a single row, with the most complicated requiring loading several multiple table modules.

<p>As moodss is written in Tcl and uses well supported extensions (Tktable and BLT), it will run on Tcl/Tk supported platforms: UNIX type and Windows (with less features, such as the moomps daemon). Obviously, some modules may be specific to a platform, but the core is guaranteed to run on them all.

<p>After reading and understanding this document, you should be able to write your own modules in order to monitor the data that you are interested in.

<p>Moodss is free software. You can redistribute it and/or modify it under the terms described in the COPYRIGHT file.

<h3><a name="required"></a>3. Installation</h3>

For a quick, hassle-free try, if you are using a Linux system, download and install the standalone <a href="http:/jfontain.free.fr/moodss-17.17.i386.tar.bz2">binary</a>, complete with all required software, which installs in a sub-directory:
<pre>$ tar -xjf moodss-17.17.i386.tar.bz2       # unpack it
$ moodss-17.17/moodss.sh cpustats memstats # now use it
$ rm -rf moodss-17.17/                     # remove it</pre>

<p>For a permanent installation, if you are using a Linux Red Hat or Fedora system (7.0 or above), then use the moodss rpm file (available at <a href="http://jfontain.free.fr/">http://jfontain.free.fr/</a>) for installation. It requires the tcl, tk, blt and tktable rpms also referenced at the same location (see INSTALL (UNIX) and install.txt (Windows) files for more information). You are then all set for using the included Linux modules or develop your own modules.

<p>For the current version (17.17), the following packages must be installed before attempting to install moodss (make sure to check the INSTALL file for the latest information):<ul>
  <li>Tcl/Tk version 8.3.1 or above (at <a href="http://tcl.sourceforge.net/">http://tcl.sourceforge.net/</a>)
  <li>tkTable version 2.7 or above (at <a href="http://tktable.sourceforge.net/">http://tktable.sourceforge.net/</a>)
  <li>the latest BLT library version 2.4z or above (at <a href="http://sourceforge.net/projects/blt/">http://sourceforge.net/projects/blt/</a>)
</ul>

<p>If you want to use the optional database history browsing feature, one or more of the following packages can be used:<ul>
  <li>mysqltcl package (at <a href="http://www.xdobry.de/mysqltcl/">http://www.xdobry.de/mysqltcl/</a>) for the MySQL database with connection via the native MySQL protocol
  <li>sqlite file based SQL library at <a href="http://www.hwaci.com/sw/sqlite/">http://www.hwaci.com/sw/sqlite/</a> (already included in moodss rpm)
  <li>tclodbc package (at <a href="http://tclodbc.sourceforge.net/">http://tclodbc.sourceforge.net/</a>) for MySQL, PostgreSQL, Oracle, DB2, ... with connection via ODBC (Open DataBase Connectivity)
</ul>

<p>The XML, DOM, BWidget, pie widgets, stooop and scwoop libraries are included in the self contained <i>moodss</i> application file. Therefore, it is not required to install the tclXML, tclDOM, BWidget, stooop, scwoop and tkpiechart packages, unless you want to work on the moodss source code itself. However, should you want to get more information on those extensions, you will find the latest versions:<ul>
  <li>stooop version 4.1 or above
  <li>switched version 2.2 or above (included in the stooop distribution)
  <li>scwoop version 4.0 or above
  <li>tkpiechart version 6.1 or above
</ul>
at <a href="http://jfontain.free.fr/">http://jfontain.free.fr/</a>:<ul>
  <li>BWidget version 1.7 or above
</ul>
at <a href="http://tcllib.sourceforge.net/">http://tcllib.sourceforge.net/</a>, and:<ul>
  <li>tclXML version 2.6 or above
  <li>tclDOM version 2.6 or above
</ul>
at <a href="http://tclxml.sourceforge.net/">http://tclxml.sourceforge.net/</a>.

<p>Finally, if you want to develop your own modules in a language other than Tcl, such as Perl or Python, you will need:<ul>
  <li>tclperl library
  <li>tclpython library
</ul>
also at <a href="http://jfontain.free.fr/">http://jfontain.free.fr/</a>.

<h3><a name="architecture"></a>4. Architecture</h3>

The moodss application is composed of the core software and one or several modules. Modules are implemented as Tcl packages and thus usually comprise a Tcl, Perl or Python source file and a pkgIndex.tcl file as required by the Tcl package implementation.

<p>The core loads one or more modules, whose names are passed as command line parameters, come from a save file or are dynamically loaded, and starts displaying module data in one or more tables. The tables are then updated at the frequency defined by the poll time, which the user may change, or asynchronously for the relevant modules. For example, to launch moodss with the random module, just type (on a UNIX machine):

<table bgcolor="#DFDFDF" width="100%"><tr><td><pre>
  $ moodss random
</pre></td><tr></table>

<p>All the module code and data are kept in a separate namespace. The module data is stored is a single array including some configuration data used when the module is loaded by the core, and variable data (displayed in the application table and possibly graphical viewers). If a module is synchronous, it must start updating its data when requested by the core. If a module is asynchronous, its data may be updated at any time. The synchronous or asynchronous nature is specified in the configuration data for the module.

<p>The initial data tables represent the first data views, from which any number of cells can be selected. Data viewers can be created by dragging and dropping cells into a graph, bar chart, pie chart, statistics and values tables, free text or thresholds sites. In turn, these viewers can display more table cells, which when dropped into the viewer, result in the creation of corresponding data graph lines, chart bars, pie slices, table rows or text cells. Cells or rows can be removed from existing viewers, by simply selecting them and dropping them in the eraser iconic site (in the shape of a pencil eraser).

<p>Any viewer can be mutated (its type changed) by dragging from a viewer icon and dropping into it. For example, create a stacked data bar viewer from several cells, then drag the 3D pie icon into it. Any viewer can also be destroyed in one shot by dropping the eraser icon into it.

<p>Any draggable data can be dropped in any valid drop site at any time. It is thus possible to drag several data cells from any table or any viewer into other ones, the thresholds interface, the eraser, ... even if the data comes from different modules.

<p>All data viewers can be moved and resized at will with the help of a simple internal window manager.

<p>The current configuration (existing pages, loaded modules, tables and viewers coordinates, sizes, poll time, main window size, ...) can be saved in a file at any time, so that an identical dashboard can be relaunched at will.

<p>Note that all configuration and preferences data is written to disk in XML 1.0 format, to follow standards, and so it is possible to edit using a plain text or specialized editor.

<h4><a name="userinterface"></a>5. User interface</h4>

Immediately after launch, module(s) is(are) loaded and initialized, with corresponding messages displayed in the message area, as follows:

<p><center><img src="/usr/share/doc/moodss-17.17/moodss5.gif" alt="moodss window view in load mode"></center>

<p>Soon after, tabular data is displayed in one or more tables, between the menu bar, the tool bar, the drop sites with graphical viewers, statistics and values tables, free text, thresholds and eraser icons, pages tabs and a message area, as one can see below:

<p><center><img src="/usr/share/doc/moodss-17.17/moodss1.gif" alt="moodss initial main window view"></center>

<p>If there are several pages (views), notebook tabs appear below the canvas area (see above).

<p>The message area is used to display status information, such as when the data is being updated, and help information, as the user moves the mouse pointer over sensitive areas, such as table column headers. Contextual help on all menu items is also activated as traversal occurs, either using the mouse or the keyboard, resulting in a short explicative string appearing in the message area and related to the active (highlighted) menu item. Further help is provided through widget tips (also known as balloons) when appropriate (on data table column headers, for example), and of course the Help menu.
<br>The message area header label also serves as a thresholds indicator for all the thresholds activated in the application. The label takes the color of the most important active threshold (according to its importance level). If there are several active thresholds of the same most important level, but with different colors, then the colors are shown in sequence, 1 per second. A widget tip also shows the most important thresholds summaries (also see <a href="#pagetabs">page tabs</a> and <a href="#message">message</a>).

<p>The window title shows the name of the loaded module(s) along with the poll time, if not in database mode.

<p>Various thresholds can also be set on any data cells, as documented in the <a href="#menus.edit.thresholds">thresholds</a> section.

<h5><a name="tables"></a>5.1. Tables</h5>

Table widgets feature the module identifier as title and automatic scroll bars.

<p>When several modules of the same type are loaded (for example, CPU statistics on a group of servers), the initial data tables feature the module name followed by an instance number (<i>module&lt;N></i>), or the module identifier generated from the module code (<i>cpustats(host.domain.org)</i> for example). A lone module keeps his unmodified name as table titles.

<p>Any data displayed in a table can be sorted (provided that the related module allows it) at any time by simply clicking on a column title. Clicking on the same column title again sorts the data in the opposite order, thus toggling between increasing and decreasing orders.
<br>When sorting, the selected column is used as a reference, meaning that all rows will be rearranged so that the selected column appears sorted, with values either increasing or decreasing.
<br>A little triangular indicator is placed to the right of the reference column title label, pointing up or down depending on whether the sorting order is decreasing or increasing.

<p>If the module allows it (most modules use automatic column sizing), table columns can be interactively resized by holding the first mouse button down on a column border. The mouse cursor is changed to an horizontal double arrow on column borders to show this capability.

<h5><a name="viewers"></a>5.2. Viewers</h5>

Aside from the main tables, graphical and textual viewers can be created for monitoring table cells in real time or deferred time, when in database mode. Viewers can be deleted, data elements (such as pie slices, curves, ...) can be added or removed from existing viewers, ... These functions are all implemented using <a href="#draganddrop">drag and drop</a>.

<p>For all viewers, if a module identifier string is required (provided by the module, several instances of the same module, ...) for proper cell identification, that string will be placed first in the label. For example, data cells originating from the third instance of the random module would be labeled: "<i>random&lt;3>: data cell label</i>".

<p>For graphical viewers (<a href="#viewers.graphs">graphs</a>, <a href="#viewers.bars">bars</a> and <a href="#viewers.pies">pies</a>), it is possible to change the displayed color of the graphical element (curve, bar or slice) used to display the cell data, by clicking with the mouse button 3 on the data cell label. A popup menu is then displayed, containing a set of color choices corresponding to the current viewers <a href="#configuration.viewers.colors">colors</a> configuration.
<br>Picking a color instantaneously changes the color of the displayed element. Such user defined colors are saved in the configuration file and properly restored.

<h6><a name="viewers.graphs"></a>5.2.1. Graphs</h6>

Graph viewers display the history of one or more data cells over some period of time (depending on the poll time and the number of samples, set in <a href="#configuration.viewers.graphs">configuration</a>). In the simple graph viewer, cells data is displayed as curves of different colors, whereas in the stacked graph case, values for each data cell are added to each other and the areas below the curves filled with color (see images below).

<p>When displaying database history data, the graph viewers display all data samples for the selected time range (see <a href="#menus.file.database">database</a> section).

<p>Graph viewers feature an automatic cross hair which follows the mouse pointer movements inside the plotting area. Corresponding coordinates are displayed in the main window message area.

<p><center><table cols=2 width="100%">
<tr align=center valign=center>
<td><img src="/usr/share/doc/moodss-17.17/hgraph.gif" alt="graph viewer sample"></td>
<td><img src="/usr/share/doc/moodss-17.17/hstackgr.gif" alt="stacked graph viewer sample"></td>
</tr>
</table></center>

<p>It is possible to fix the Y axis (ordinate) maximum value. This limit can either be fixed or dynamically follow the value of any data cell.

<p>To set a fixed value, click with the mouse button 3 on any part of the viewer to display a popup menu. After selection, an entry zone is created in the upper left corner of the viewer (see pictures above).
<br>Just type in the new value, or an empty string if you want to remove the maximum value and to restore the default behavior.
<br>By default, the Y axis of a graph automatically scales based on the displayed data values.
<br>Once the maximum entry is visible, use the <b>Enter</b> key to validate your choice or the <b>Escape</b> key to cancel the operation.
<br>A small red arrow next to the maximum value is used as an indicator that the maximum value has been set (see pictures above).

<p>To set a dynamic value, drop any data cell in the upper left corner of the viewer. The drop area then materializes a small rectangle with black borders. Drop the data cell and from then on, its value is used as the dynamic maximum of the viewer.
<br>To change the dynamic value, you may drop another data cell as a replacement, or change to a fixed value as described above, or delete the dynamic limit data cell by entering an empty fixed value.

<p>When placing the mouse cursor in the upper left corner of the viewer, a help tip is displayed showing the current state of the limit for the viewer (either none set, fixed value set or dynamic value with the name of the data cell used).

<p>From the <a href="#configuration.viewers.graphs">configuration</a> or <a href="#core.preferences">preferences</a> dialog boxes, it is possible to set the angle of the X axis labels (from 45 degrees to the default 90 degrees).

<h6><a name="viewers.bars"></a>5.2.2. Bars</h6>

Bar chart viewers available at this time are side-by-side bars charts, overlapped bars charts and stacked bars charts. In the stacked bars charts case, cells data values are added to each other, whereas in the others, they are displayed next to each other, overlapping or not (see pictures below).

<p>When displaying database history data, the bar chart viewers display the values at the time selected by the right side cursor in the database module instances viewer (see <a href="#menus.file.database">database</a> section).

<p><center><table cols=2 width="100%">
<tr align=center valign=center>
<td><img src="/usr/share/doc/moodss-17.17/hoverbar.gif" alt="overlap bar chart viewer sample"></td>
<td><img src="/usr/share/doc/moodss-17.17/hsidebar.gif" alt="side bar chart viewer sample"></td>
<td><img src="/usr/share/doc/moodss-17.17/hstackbr.gif" alt="stacked bar chart viewer sample"></td>
</tr>
</table></center>

<p>Just as in the graph viewers, it is possible to fix the Y axis (ordinate) maximum value of a bar chart viewer.

<h6><a name="viewers.pies"></a>5.2.3. Pies</h6>

Pie viewers come in 2 types: 2D or 3D. The data cells values can either be placed around the pie area or next to the labels (see <a href="#configuration.viewers.pies">configuration</a>).

<p>In database browsing mode, dynamic values take the values at the latest of the 2 times defined by the cursors (see the <a href="#menus.view.database.range">database range</a> section).

<p><center><table cols=2 width="100%">
<tr align=center valign=center>
<td><img src="/usr/share/doc/moodss-17.17/h2dpie.gif" alt="2D pie chart viewer sample"></td>
<td><img src="/usr/share/doc/moodss-17.17/h3dpie.gif" alt="3D pie chart viewer sample"></td>
</tr>
</table></center>

<p>It is possible to fix the total value (corresponding to 100 % of the pie). This limit can either be fixed or dynamically follow the value of any data cell.

<p>To set a fixed value, click with the mouse button 3 on any part of the viewer to display a popup menu. After selection, an entry zone is created in the upper left corner of the viewer (see pictures above).
<br>Just type in the new value, or an empty string if you want to remove the total value and to restore the default behavior.
<br>By default, the slices of a pie automatically scales based on the displayed data values, so that their total always match 100 %.
<br>Once the total entry is visible, use the <b>Enter</b> key to validate your choice or the <b>Escape</b> key to cancel the operation.
<br>A small red arrow next to the total value is used as an indicator that the total value has been set (see pictures above).

<p>To set a dynamic value, drop any data cell in the upper left corner of the viewer. The drop area then materializes a small rectangle with black borders. Drop the data cell and from then on, its value is used as the dynamic total of the viewer.
<br>To change the dynamic value, you may drop another data cell as a replacement, or change to a fixed value as described above, or delete the dynamic limit data cell by entering an empty fixed value.

<p>When placing the mouse cursor in the upper left corner of the viewer, a help tip is displayed showing the current state of the limit for the viewer (either none set, fixed value set or dynamic value with the name of the data cell used).

<h6><a name="viewers.tables"></a>5.2.4. Tables</h6>

The statistics table displays, for each row, the cell label, the current, average, minimum and maximum values, either since the row was created in real-time mode, or over the period delimited by the 2 times defined by the cursors in database mode. (see the <a href="#menus.view.database.range">database range</a> section).

<p>Data cells can be inserted one or several at a time through a simple drop. Rows can be deleted by selecting any cell in the row then dropping any number of them into the eraser drop site. Data cells with missing data (could be no longer available if coming from a vanished process, for example) display the ? character. When displaying database history data, the average, minimum, and maximum values are calculated for the selected time range.

<p><center><table width="100%">
<tr align=center valign=center>
<td><img src="/usr/share/doc/moodss-17.17/hsumtbl.gif" alt="statistics table viewer sample"></td>
<td><img src="/usr/share/doc/moodss-17.17/valuetab.gif" alt="values table viewer sample"></td>
</tr>
</table></center>

<p>The values table displays for each row the cell label and the current values of the cell data. It behaves exactly as the statistics table, but without the average, minimum and maximum columns. It can be used in dashboards to display cells that are hidden when the corresponding module tables are iconified.
<br>In <a href="#menus.file.database.load">database browsing mode</a>, the values table behaves differently: it displays the history of the dropped data cell (there can be only one), which is all the values archived for that data cell within the <a href="#menus.view.database.range">database time range</a>. The number or displayed rows is limited (see <a href="#configuration.viewers.tables">tables configuration</a>). If the data is so truncated, an initial blank row is displayed as an indicator:

<p><center><img src="/usr/share/doc/moodss-17.17/valuetab2.gif" alt="values table viewer sample in history mode, with data truncation"></center>

<h6><a name="viewers.text"></a>5.2.5. Text</h6>

The free text viewer is an editable Tk text widget with any number (including zero) of embedded data cell windows. Data cells can be inserted one or several at a time through a simple drop, as with the other viewers. New data cell windows are inserted at the current insertion cursor position. Data cells can be deleted by selecting then dropping any number of them into the eraser drop site. They can also be deleted using the keyboard Delete and Backspace keys, which also work on the regular text, as well as the expected other key bindings. When dropping data cells, each data cell window is preceded by a relevant label text for the cell, which can later be edited at any time.

<p><center><table width="100%">
<tr align=center valign=center>
<td><img src="/usr/share/doc/moodss-17.17/hfreetxt.gif" alt="free text viewer sample"></td>
</tr>
</table></center>

<p>When displaying database history data, the displayed values are at the time selected by the right side cursor in the database module instances viewer (see <a href="#menus.file.database">database</a> section).

<h6><a name="viewers.examples"></a>5.2.6. Examples</h6>

Here is a screen shot of loaded <i>ps</i> and <i>cpustats</i> modules with several graphical viewers:

<p><center><img src="/usr/share/doc/moodss-17.17/moodss3.gif" alt="moodss window with graph data viewers"></center>

<p>Here is another shot featuring a free text viewer with loaded <i>cpustats</i> and <i>memstats</i> modules:

<p><center><img src="/usr/share/doc/moodss-17.17/moodss4.gif" alt="moodss window with free text data viewer"></center>

<h5><a name="titlebar"></a>5.3. Title bar</h5>

When not in database mode, the title bar shows the currently loaded modules and the current poll time, if any (there could be only asynchronous modules loaded), as the following image shows:

<p><center><img src="/usr/share/doc/moodss-17.17/titlebar.gif" alt="title bar"></center>

<h5><a name="menus"></a>5.4. Menu bar</h5>

<center><img src="/usr/share/doc/moodss-17.17/menubar.gif" alt="menu bar"></center>

<h6><a name="menus.file"></a>5.4.1. File</h6>

<h6><a name="menus.file.new"></a>5.4.1.1. New</h6>

As in the <a href="#menus.file.exit">exit</a> menu, if there are unsaved changes, the user is given the opportunity to save them to a file before all existing modules are unloaded, along with any viewers.

<h6><a name="menus.file.open"></a>5.4.1.2. Open</h6>

This menu entry allows the user to open an existing saved configuration file (also useful for editing moomps configuration files) to replace the currently loaded modules and viewers with those described in the file to open.

<p>As in the <a href="#menus.file.exit">exit</a> menu, if there are unsaved changes, the user is given the opportunity to save them to a file before opening the new file.

<p>Note that all existing modules will be unloaded, along with any viewers, prior to loading the configuration from the open file, thus acting as if the open file was directly and initially loaded when moodss was started.

<h6><a name="menus.file.save"></a>5.4.1.3. Save</h6>

The current application configuration (including existing data viewers) can be saved in a file, which achieves a dashboard functionality. The format used for saving is XML, as the following saved file extract shows:

<table bgcolor="#DFDFDF" width="100%"><tr><td><pre>
&lt;?xml version='1.0'?&gt;
&lt;!DOCTYPE moodssConfiguration&gt;

&lt;moodssConfiguration&gt;
  &lt;version&gt;16.8&lt;/version&gt;
  &lt;date&gt;12/26/02&lt;/date&gt;
  &lt;time&gt;21:29:38&lt;/time&gt;
  &lt;configuration graphNumberOfIntervals="100" canvasBackground="#fff4ff" canvasWidth="1152" pieLabeler="peripheral" canvasHeight="864" graphMinimumY=""&gt;
    &lt;viewerColors&gt;
      &lt;item&gt;#feffff&lt;/item&gt;
      ...
</pre></td><tr></table>

<p>Once moodss has been launched with one or several modules and tables have been moved, resized, viewers created, moved and resized, the current configuration can be saved in a .moo file, and later reused by passing the corresponding file name with the <i>-f (--file)</i> command line switch, or by using the <a href="#menus.file.open">File Open</a> menu.

<p>The following information is saved in the file (which is human readable):<ul>
  <li>moodss version
  <li>date and time
  <li>application window size
  <li>poll time
  <li>modules
  <li>tables positions and sizes
  <li>viewers types, positions, sizes and specific data
  <li>table viewers column widths
  <li>viewers stacking order (for internal window manager)
  <li>global configuration (such as canvas color, sizes, ...) (see <i>Edit</i> menu)
  <li>pages tab labels
</ul>

<p>When using this menu for the first time, and if a file name was not specified in the command line, the file selector dialog box appears so that the user may choose a file name (with a <i>.moo</i> extension).

<p>Once a file name has been specified (either through the command line or the file selector dialog box), that file name is reused whenever the <i>File Save</i> menu is used.

<h6><a name="menus.file.saveas"></a>5.4.1.4. Save as</h6>

This menu behaves as expected, with the user always having to choose a file name using the file selector dialog box (see <i>Save</i> menu above).
<br>This menu may be used at any time to change the current save file name.

<h6><a name="menus.file.modules"></a>5.4.1.5. Modules</h6>

<h6><a name="menus.file.modules.load"></a>5.4.1.5.1. Load</h6>

You can dynamically load a module by simply selecting its name from the available list discovered when the selection window opens. When the module is selected, its options appear and any number of them can be filled (options ending with <i>password</i> show <i>*</i> characters when the user types in the option value). The module documentation can be simply accessed by clicking on the <i>Help</i> button.

<p>Note that, during the lifetime of the application, if there was an attempt to load an instance of the selected module, the values used at that time for the module options are reused.

<p>Once the new module, or new instance of an already loaded module, is loaded, the application behaves as if the module had been loaded from the start. Use the <i>Close</i> button when done loading modules.

<h6><a name="menus.file.modules.manage"></a>5.4.1.5.2. Manage</h6>

This dialog box allows the user to:<ul>
  <li>view a list of the currently loaded modules
  <li>select a module and view its configuration (command-line options and their values)
  <li>get <b>help</b> on a loaded module
  <li>change the configuration of a module and <b>reload</b> it
  <li>change the configuration of a module and launch a <b>new</b> instance
  <li><b>unload</b> a module
</ul>

<p>Once a module is unloaded, the module data tables disappear, but the viewers containing cells pointing to the module data remain, simply showing that the data is now invalid.

<p><i>Note</i>: if a module is reloaded, or unloaded then loaded again, viewers that monitored the unloaded module data will not resume monitoring the newly loaded module data since internally Tcl traces on variables were removed.

<p>When selected, the module current options appear (options ending with <i>password</i> show <i>*</i> characters in the option value). The selected module documentation can be simply accessed by clicking on the <i>Help</i> button.

<p>Use the <i>Close</i> button when done.

<h6><a name="menus.file.modules.loaded"></a>5.4.1.5.3. Loaded</h6>

View the loaded modules and their options, without the possibility of unloading a module. This menu entry is available for example when moodss is started in read-only mode (see <a href="#commandline">Command line</a>).

<p>A module can be picked from a list of the currently loaded modules. If any, the module current options appear (options ending with <i>password</i> show <i>*</i> characters in the option value). The selected module documentation can be simply accessed by clicking on the <i>Help</i> button. Use the <i>Close</i> button when done.

<h6><a name="menus.file.database"></a>5.4.1.6. Database</h6>

Both the moodss GUI application and the moomps daemon have the capability of storing history over time of any module data cells, by saving their values in a database (also see the preferences <a href="#preferences.application.database">database</a> and <a href="#preferences.moomps">moomps</a> sections, and the <a href="#faq">frequently asked questions</a>).

<p>From this menu, it is possible to thoroughly browse the history database, while keeping a user interface (drag'n'drop, viewers, help, ...) behaving as in real time monitoring.

<p>When any database related error occurs, the <a href="#menus.view.trace">trace</a> window is automatically opened and displays the related error messages.

<h6><a name="menus.file.database.load"></a>5.4.1.6.1. Load</h6>

This menu (or its associated button in the <a href="#menus.view.toolbar">tool bar</a>) opens the database instances dialog box (provided database access is properly configured), and shows (with possibly a small delay depending on the speed of the database used) all the module instances, as the following screen shot shows:

<p><center><img src="/usr/share/doc/moodss-17.17/dbgui.gif" alt="database instances dialog box"></center>

<p>Note that you will be given the opportunity to save your configuration if you were monitoring in real time with some loaded modules, prior to switching to database mode (deferred time).

<p>A tree shows all the module names, with instances containing data cells stored in the database (also see the <a href="#menus.edit.database">database</a> edit menu). Below each module name, all the instances for that module are shown when clicking on the <b>+</b> tiny icon. Finally, below each instance, all the data cells can be found, with their comments in parentheses, if any.

<p>Clicking on any tree node displays, possibly after a small delay, the time range in the database for that item. For example, clicking on a module name would show the date and time of the oldest cell data sample for all instances of that module, along with the date and time of the most recent sample, at the time the dialog box was opened.

<p>Clicking on the <b>SQL</b> button while a data cell is selected show the SQL query that can be used to retrieve all the data samples for that cell. For example, that can help when developing an external application accessing the database.

<p>To actually load an instance into the moodss GUI, either select the desired instance and then click the <b>OK</b> button (which closes the dialog box), or drag any number of instances (but one at a time) into the database module instances viewer (as seen in the picture below) while keeping the dialog box opened.

<p><center><img src="/usr/share/doc/moodss-17.17/database.gif" alt="moodss window view in database mode"></center>

<p>For each instance, the available extent of time for all data cells histories for that instance is shown on the time scale of the database module instances viewer. If an instance contains only data cells with empty histories, an endless dotted line is shown (as seen above for the <i>random</i> module). The module options for each instance can be displayed in a widget tip by keeping the mouse pointer over an instance name.

<p>For each displayed instance, a corresponding data table is also displayed (see the <i>snmp</i> data table in the screen shot above). For each data cell, the corresponding comment (if it exists, see the <a href="#menus.edit.database">database</a> edit menu) or the data cell name is displayed in the left column, while the last values are displayed on the right side. The original module help for data is preserved and can be accessed via a widget tip, which appears when the mouse pointer is placed on top of a data cell label.

<p>From then on, all the functionality that you are used to in real time mode is available to you (expect for the thresholds settings which only make sense while monitoring in real time). As an example, in the screen shot above, the <i>WAN input</i> and <i>output</i> traffic cells were dropped in a stacked graph viewer, which after a delay depending on the database engine speed and the amount of stored history data, displayed the complete history for both cells.

<p>A specific range within the time extent can be set using the blue cursors in the database module instances viewer (just drag them with the mouse and refresh the display by clicking on the refresh button or using the <a href="#menus.view.refresh">refresh</a> view menu).
<br>Alternately, the <a href="#menus.view.database.range">View Database range</a> menu can be used to precisely set the date and time limits from a dialog box. Note that the cursors and the database range dialog box are synchronized: moving a cursor results in the date and time values being updated in the dialog box.
<br>All the views are then updated, with the viewers either showing the complete history or the value at the right cursor, depending on their type (the statistics table viewer shows the average, minimum, maximum, ... values for the selected time range).
<br>Finally, in any displayed graph data viewers, you may drag a time value directly from the cross hair (see <a href="#userinterface.crosshairs">user interface</a>) and drop it into the database instances viewer: the closest blue cursor will move to the time value. Then hit the refresh button to update the display. This technique allows fine tuning of the display to a specific time range, directly from any graph viewer.

<p>Module instances can be unloaded by dragging from their name in the database module instances viewer into the eraser drop site.

<h6><a name="menus.file.database.start"></a>5.4.1.6.2. Start</h6>

Starts recording data history over time in the database (defined in <a href="#preferences.database">preferences</a>) for the cells specified in the <a href="#menus.edit.database">database interface</a>.
<br>You may also use the associated button in the <a href="#menus.view.toolbar">tool bar</a>.
<br>Data storage can be stopped at any time using the <a href="#menus.file.database.stop">Stop</a> menu. Then data history can be displayed and manipulated using the <a href="#menus.file.database.load">Load</a> menu.

<p>While recording, errors, such as disconnections when the database server becomes unreachable, are handled by gracefully disconnecting and retrying to connect at each update, thus greatly enhancing reliability.

<p><i><b>Note</b>: when data history is being recorded, if the tool bar is visible, the VCR like record button is disabled and surrounded by a bright red ring (see <a href="#menus.view.toolbar">tool bar</a> screen shot).</i>

<h6><a name="menus.file.database.stop"></a>5.4.1.6.3. Stop</h6>

Stops recording data history in the database, process started using the <a href="#menus.file.database.start">Start</a> menu.
<br>You may also use the associated button in the <a href="#menus.view.toolbar">tool bar</a>.

<h6><a name="menus.file.print"></a>5.4.1.7. Print</h6>

You can print the canvas area in postscript to a printer or a file, which you may choose using the classical file browser. Please note that only the strictly visible area, without the scrollbars, will be printed.

<p>You can choose the printout orientation (portrait or landscape), palette (color, gray scale or monochrome) and the paper size.

<p>Due to widget and architecture limitations, the printout is pixel based. As a benefit, it is extremely WYSIWYG :-).
<br>Also, because of design limitations, printing is disabled on Windows platforms.

<p>The printout is sized according to the following rules:<ul>
  <li>empty space, around tables or data viewers, is not included (the area is cropped)
  <li>a margin of 0.5 inch (12.7 millimeters) is used both horizontally and vertically on all sides
  <li>size reduction occurs equally horizontally and vertically (aspect ratio is preserved) only when necessary so that all tables and data viewers are visible on the printout
</ul>

<p>When the print menu entry is selected, a dialog box appears, as can be seen in the screen shot below (which also shows the preview window in the background):

<p><center><img src="/usr/share/doc/moodss-17.17/moodss7.gif" alt="print dialog box with preview window"></center>
<br>You can choose to send the postscript data to a printer or to the screen for previewing.

<p>Depending on the print configuration (see <a href="#core.preferences">Preferences</a>), either a print command line entry or a printer selection list appears below the informational message (<i>note: successfully tested against the Berkeley LPR print spooler and the Common UNIX Printing System (CUPS)</i>). Hitting the OK button sends the data to the selected printer or through the specified command line.

<p>The preview functionality uses <em>gs</em> (also known as ghostscript), which must be installed (<i>note</i>: version 5.50 or above is required, as 5.10 is buggy). If gs cannot be found or executed, the preview button is grayed. If the gs version is below 5.20, the button is also grayed and a window tip explaining the cause is displayed when the mouse pointer is located above the button.

<p>When the gs utility is available and of the correct version, the preview button can be depressed, in which case the print dialog temporarily disappears (so that the application main window is not obscured), and reappears along with the preview window, once the printout view has been calculated.
<br>The preview window also features a zoom menu for resizing. If the user so desires, one or more printing parameters, such as page size, orientation, ... can be changed while the preview window remains visible. Hitting the preview button then results in both the print dialog box and the preview window to temporarily disappear while the new page look is calculated. After a short while, they both reappear with the preview updated accordingly, and having kept the same zoom ratio.

<p>Also note that due to the implementation of the graphical layer on UNIX systems, any window or object obscuring the canvas area will also be printed, but this is unlikely, as the moodss application window will be in front when the print menu item is selected.

<h6><a name="menus.file.exit"></a>5.4.1.8. Exit</h6>

Use this menu to gracefully quit the moodss application. You may also use the window manager to close the application.

<p>If there are unsaved changes (configuration, viewers created, tables or viewers moved, stacked, ...), the user is given the opportunity to save them to file (see <a href="#menus.file.save">File Save</a> menu). The file selector dialog box is used if no save file name is currently known by the application.

<h6><a name="menus.edit"></a>5.4.2. Edit</h6>

<h6><a name="menus.edit.thresholds"></a>5.4.2.1. Thresholds</h6>

Using this menu or dropping cells into the thresholds drop site in the main window results in the following dialog box being displayed. While displayed, user interaction with other parts of the user interface remains possible, so that more cells can be dropped into the thresholds dialog box table itself.

<p><center><img src="/usr/share/doc/moodss-17.17/moodss8.gif" alt="thresholds user interface"></center>

<p>A list of threshold entries is displayed in a table with the following columns:

<ul>
  <li><b>active</b>: Clicking on the check button toggles the state of the entry between active and not. When active, the shell script is invoked when and if the threshold condition occurs. For example, if the threshold type is <i>up</i> and the data cell value goes above the threshold value.
  <li><b>type</b>: Clicking on the entry icon toggles the threshold type between <i>differ</i>, <i>down</i>, <i>equal</i>, <i>unknown</i> and <i>up</i> (see threshold types below).
  <li><b>once</b>: Whether actions (email and script) will be invoked only once after the threshold condition is met, with the related internal state being reset when the threshold condition is no longer met. For example, if the threshold type is <i>up</i>, and email will be sent at the time the data value goes above the threshold, but not while it stays above. If the value goes below the threshold, then another email will be sent once the threshold is crossed again. <i>Note: not checked by default for backward compatibility.</i>
  <li><b>level</b>: Importance level settable using a pop-up selector. When a cell has several thresholds active, it will take the color of the most important threshold. It is also be included in the email alert message and is used by moomps to set the system logging importance level for the threshold log entry. Defaults to <i>notice</i>. Possible values are, in increasing importance order: <i>debug</i>, <i>info</i>, <i>notice</i>, <i>warning</i>, <i>error</i>, <i>critical</i>, <i>alert</i>, <i>emergency</i>.
  <br>Changing the level may also automatically change the color to be displayed in source cell(s) (see below).
  <li><b>color</b>: Selects the color to be displayed in source cell(s) when the threshold condition occurs. Clicking on the menu button drops a menu window with predefined color buttons, the last of which, with 3 dots as a label, if selected, opens a custom color selection dialog box. The menu button color reflects the currently selected threshold color. The <b>?</b> entry stands for transparency, that is there will be no color change in the monitored cell displays when the threshold condition occurs. Note that this color is automatically updated when the importance level is changed (see above), provided the color was not previously set to a custom value by the user.
  <li><b>actions</b>: a small envelope icon (<img src="/usr/share/doc/moodss-17.17/mail.gif" alt="mail">) is displayed when there is at least one email recipient specified in the list of email addresses (see below), with a yellow tint (<img src="/usr/share/doc/moodss-17.17/maily.gif" alt="custom mail">) when the mail message is not the default (see below), and a small gear icon (<img src="/usr/share/doc/moodss-17.17/gear.gif" alt="gear">) is displayed when the threshold script (see below) is not empty.
  <li><b>value</b>: The threshold value, used as reference when comparing with the data cell current value. When changed, the threshold condition is checked as the user confirms when closing the dialog window.
  <li><b>source</b>: Initially, when the threshold entry is created, the data cell label, as it would be displayed in a data viewer. This column is editable so that the user may input a more meaningful description.
</ul>

<p>Additionally, when a row is selected, the following fields become available in the lower area of the dialog box:<ul>
  <li><b>Initial condition</b>: if the threshold condition is met most of the time, such as an initial condition, you can disable acting at application start by checking this button (see example in <a href="#menus.edit.thresholds.notes">notes</a>).
  <li><b>Emails</b>: an editable list of email addresses. To enter a new address, simply hit the &lt;Return&gt; of &lt;Enter&gt; key in any filled cell. An empty cell is then created at the bottom of the list. To delete an address, simply empty it using the usual &lt;Backspace&gt; or &lt;Delete&gt; editing keys.
  <br>When a threshold event occurs, an alert message will be sent to each recipient (also see <a href="#preferences.thresholds.email">preferences</a>). Any error occurring when attempting to send mail will be visible in the <a href="#menus.view.trace">trace</a> module. See below for more information on email messages.
  <li>The <b>Original cell</b> label.
  <li>The corresponding data cell <b>Current value</b>.
  <li>Whether the <b>default</b> mail message is used (as set in the preferences <a href="#preferences.thresholds.email">email</a> section).
  <li>The custom <b>Mail message</b> section (which is hidden or displayed by clicking on the little arrow button), and becomes available if the <b>default</b> button is not checked:<ul>
    <li>The mail <b>Subject</b> line (may include % substitutions, see below).
    <li>The mail <b>Body</b> text (may also include % substitutions, see below).
    <li>You may also include a screen shot (in JPEG format) of the moodss window at the time the threshold occurred, by ticking the check button, next to the little <b>camera</b> icon.
    <br><i><b>Note</b>: the screen shot may turn out to be black, depending on whether the moodss window was visible when the threshold occurred, due to the X Window System implementation. More work needs to be done in that area to solve that problem.</i>
  </ul>
  <li>The <b>Script</b> section (which is hidden or displayed by clicking on the little arrow button):<ul>
    <li>An editable text area can be used to enter a UNIX <b>script</b> or Windows command script, invoked when the threshold is crossed. See script section below for passing arguments to the script.
    <li>The <b>Test trace</b> area, which displays the output of the script (if any and including errors), when the <b>Test</b> button is clicked. Errors are always visible in the trace module data table if displayed.
  </ul>
  <li><b>Test</b> button (at the bottom of the dialog box): simulates a threshold condition. The shell script is then invoked as if the real threshold was crossed, the cell value being artificially generated. Any output generated by the shell script is displayed in the test trace area. A mail message, default or custom, is sent to the specified email addresses. Displayed source cell(s) in the main application window remain unaffected color-wise.
  <li><b>Delete</b> button (at the bottom of the dialog box): removes the selected threshold entry (row). All related displayed source cells are reset to their original (transparent) color.
</ul>

<p>Sample threshold email message (the default):
<pre>From: moomps@localhost.localdomain
To: jfontain@localhost.localdomain
Subject: moodss threshold warning message

warning: "random: Robert top disk" data value is now "11",
which triggered the "up" threshold of "10".</pre>

<p>Selecting a row is done by clicking on any cell of the row. The row is then highlighted.
<br>When selecting another row in the thresholds table, or closing the dialog box using the OK button, the syntax of the displayed emails is checked and errors, if any, reported in a message box. It is then recommended to test that emails actually get sent and to the right recipients, using the test functionality described below.

<p>Help is provided through widget tips on the table title cells, and a help button, which directly opens the main help window at the relevant section.

<p>Creating threshold entries is done through the drag'n'drop mechanism by dropping data cells into the thresholds drop icon or into the thresholds dialog box table itself (provided it is open, of course). Any number of thresholds can be set on the same data cell.

<h6><a name="menus.edit.thresholds.types"></a>5.4.2.1.1. Types</h6>

The following threshold types are supported:<ul>
  <li><img src="/usr/share/doc/moodss-17.17/differ.gif" alt="differ">&nbsp;: threshold and cell value must differ.
  <li><img src="/usr/share/doc/moodss-17.17/down.gif" alt="down">&nbsp;: cell value must be less than threshold.
  <li><img src="/usr/share/doc/moodss-17.17/equal.gif" alt="equal">&nbsp;: threshold and cell value must be equal.
  <li><img src="/usr/share/doc/moodss-17.17/unknown.gif" alt="unknown">&nbsp;: cell value must be unknown (void).
  <li><img src="/usr/share/doc/moodss-17.17/up.gif" alt="up">&nbsp;: cell value must be more than threshold.
</ul>

<p>Depending on the source data cell type, specific internal comparison techniques are used.

<p>For the ASCII type, the current cell value can be lexicographically less than, equal to, or greater than the threshold value. Empty threshold values are allowed. The strings are compared in a case-insensitive manner.

<p>The dictionary type is handled as the ASCII type, with case ignored except as a tie-breaker and if there are embedded numbers, the numbers compare as  integers, not characters.

<p>For the clock type, the cell and threshold values are first converted to seconds, then compared.

<p>When the threshold type is <img src="/usr/share/doc/moodss-17.17/unknown.gif" alt="unknown">, the condition occurs when the data cell value cannot be determined, and only in such a case. It is the only type of threshold that can be triggered by the void nature of a data cell.
<br>This condition can happen when a data cell (of any type) no longer exists (for example, when its row has disappeared), or the data cell is of numeric type, still exists but contains void data (displayed as <i>?</i>).
<br>For other types of data cells, the displayed value when the data cell becomes void should be documented in the module help, and setting a threshold on such a cell being void should instead be done using the equal (<img src="/usr/share/doc/moodss-17.17/equal.gif" alt="equal">) threshold type on the specified value.

<p>Note that for each type, you may choose for the thresholds actions to be taken only once by checking the <i>once</i> column.

<h6><a name="menus.edit.thresholds.color"></a>5.4.2.1.2. Color</h6>

If a non-transparent color has been selected (see previous section), whenever the threshold condition occurs, all displays of the monitored data cell change color (in data tables or in viewers), and return to their normal color when the threshold condition no longer exists.

<p>When several thresholds are placed on the same data cell with different colors, and they all trigger, the behavior is undefined at this time (but the most recent threshold is likely to prevail).

<h6><a name="menus.edit.thresholds.script"></a>5.4.2.1.3. Script</h6>

Whenever a threshold is triggered (the manner of which depends on the type), the corresponding script is passed to the UNIX shell interpreter (the <i>sh</i> UNIX command), after variable substitution.

<p>Substitution occurs prior to script invocation if the script contains any % characters. Each % and the character following it is replaced with information from the threshold occurrence. The replacement depends on the character following the %, as defined in the following list:<ul>
  <li><b>%%</b>: replaced by a single %.
  <li><b>%A</b>: the name of the application (either <i>moodss</i> or <i>moomps</i>).
  <li><b>%c</b>: replaced by the original data cell string (as would be displayed in any data viewer).
  <li><b>%l</b>: replaced by the importance level string (<i>alert</i>, <i>warning</i>, ...)
  <li><b>%s</b>: replaced by the contents of the source column from the thresholds table.
  <li><b>%t</b>: the threshold value
  <li><b>%T</b>: the threshold type (<i>differ</i>, <i>down</i>, <i>equal</i>, <i>unknown</i>, <i>up</i>, ...)
  <li><b>%v</b>: the data cell value responsible for triggering the threshold
</ul>

<p>Any error returned by the script is visible in the <a href="#menus.view.trace">trace</a> module.

<h6><a name="menus.edit.thresholds.dragging"></a>5.4.2.1.4. Dragging</h6>

When a row is selected, it is possible to drag from the current cell value display, into the thresholds table itself to create a new entry for the same cell, or into any viewer icon or existing viewer.

<h6><a name="menus.edit.thresholds.notes"></a>5.4.2.1.5. Notes</h6>

When the dialog box is displayed, existing thresholds are sorted according to their importance level with the most important on top. If several thresholds of the same type and same importance level are set on the same cell, the highest (according to the cell data type) threshold is displayed first.
<br>When new thresholds are interactively added to the dialog box, they are displayed at the bottom of the thresholds table, but will be sorted as the others the next time the dialog box is opened.

<p>While the thresholds dialog box is visible, threshold conditions are not checked by the software, which means no cell color changes, no email alerts, ... can occur.

<p>Internally, threshold conditions are checked in reverse order compared to the displayed order, that is the most important thresholds last. As a consequence, color gradients on a cell are automatically achieved.
<br>For example, if you set the 3 following <i>up</i> thresholds of the same importance level (does not matter in this case, say <i>info</i>) on the same cell:<ul>
  <li>color: <i><font color="yellow">yellow</font></i>, value: <i>80</i>
  <li>color: <i><font color="orange">orange</font></i>, value: <i>90</i>
  <li>color: <i><font color="red">red</font></i>, value: <i>95</i>
</ul>

<p>you will get a color gradient effect, as the cell value approaches 100, it will turn <i><font color="yellow">yellow</font></i>, <i><font color="orange">orange</font></i> then <i><font color="red">red</font></i>.

<p>You can also force color gradients on a cell by combining importance levels and colors.
<br>For example, if you set the 3 following <i>up</i> thresholds on the same cell:<ul>
  <li>level: <i>notice</i>, color: <i><font color="yellow">yellow</font></i>, value: <i>80</i>
  <li>level: <i>warning</i>, color: <i><font color="orange">orange</font></i>, value: <i>90</i>
  <li>level: <i>alert</i>, color: <i><font color="red">red</font></i>, value: <i>95</i>
</ul>

<p>you will get an importance color gradient effect as the cell value approaches 100.

<p>If the threshold condition is met most of the time, such as an initial condition, you can disable acting at application start by checking the <b>initial condition</b> button (see example in <a href="#menus.edit.thresholds.notes">notes</a>).
<p>The <b>initial condition</b> button, when checked, prevents any action from being taken when the application (moodss or moomps) is started.
<br>It is useful when the threshold condition is "normal". For example, when monitoring a network link, you want to be warned when it goes down (for example by checking that the <i>ifOperStatus</i> is <i>down</i> using the <i>snmp</i> module), but you also need the information that the link is back up (by checking that the <i>ifOperStatus</i> is <i>up</i>). Unfortunately, using this technique, you would get an email stating that the link is up every time the application is started. Checking the <b>initial condition</b> button prevents it.

<p><i>There are still a lot of features to implement: please see the TODO file.</i>

<h6><a name="menus.edit.configuration"></a>5.4.2.2. Configuration</h6>

When selected, this menu launches the configuration dialog box, as described in <a href="#core.configuration">Configuration</a>.

<h6><a name="menus.edit.newpage"></a>5.4.2.3. New page</h6>

Creates a new page after the existing pages. If there are no pages, that is all modules are displayed in the sole main window canvas, those contents are placed in the first page just created. The page is then displayed, its tab opened in editing mode so the label can be immediately set by the user.

<p>To delete a page, just grab its tab and drop it in the eraser drop site. Note that a page must be empty of any table of viewer before it can be deleted, except for the last remaining page, the deletion of which results in only its tab being removed.

<h6><a name="menus.edit.newviewer"></a>5.4.2.4. New viewer</h6>

Allows the creation of empty viewers of any type (graph chart, stacked graph chart, overlap bar chart, side bar chart, stacked bar chart, 2D pie chart, 3D pie chart, statistics table, values table or free text).
<br>This menu is only visible when not running in read-only mode (see <a href="#commandline">Command line</a>).

<h6><a name="menus.edit.database"></a>5.4.2.5. Database</h6>

Opens the database dialog box, a drop site for modules data cells. The cells dropped in the database dialog box will be monitored by moodss (see the <a href="#menus.file.database.start">Database Start</a> menu) or the moomps daemon (provided of course that the configuration file (see <a href="#menus.file.save">Save</a> menu) is used by the moomps service).

<p>The dialog box displays a table, the drop site, with the following columns:<ul>
  <li>The data cell <b>label</b>, as it would be displayed in a data viewer
  <li>Whether archiving is <b>active</b>, which is whether the data cell history should be stored in the database
  <li>The <b>current</b> value of the data cell (useful to see if the data is currently valid)
  <li>A <b>comment</b> to be stored in the database for that specific cell
</ul>

<p>When the moomps service is running, any number of data cells can be monitored over time, using a SQL database as storage mean. The cells values are stored in the database, which can then be used from, for example, a spreadsheet software. Using such tools, it becomes possible, for example, to create history graphs, presentations, ... using the moodss database as data source. (more information can be found in the <a href="moomps.htm">moomps documentation</a>).

<p>For example, if you want to monitor CPU usage over time on a Linux server, load the <i>cpustats</i> module, open the database dialog box, drag and drop the <i>user</i>, <i>system</i> and <i>nice</i> cells in the database interface and finally save the configuration in a <i>.moo</i> file within the moomps configuration directory.

<p>Note that only cells coming from an original module table can be dropped in the database window. If you attempt to drop a cell from say a statistics table, the cell will not appear in the database window and an error message will be displayed in the main application window message area.

<h6><a name="menus.edit.preferences"></a>5.4.2.6. Preferences</h6>

When selected, this menu launches the preferences dialog box, as described in <a href="#core.preferences">Preferences</a>.
<br>The format used for saving the preferences is XML, as the following preferences file extract shows:

<table bgcolor="#DFDFDF" width="100%"><tr><td><pre>
&lt;?xml version='1.0'?&gt;
&lt;!DOCTYPE moodssPreferences&gt;

&lt;moodssPreferences&gt;
  &lt;version&gt;16.8&lt;/version&gt;
  &lt;date&gt;12/26/02&lt;/date&gt;
  &lt;time&gt;21:29:31&lt;/time&gt;
  &lt;traceNumberOfRows&gt;20&lt;/traceNumberOfRows&gt;
  &lt;printToFile&gt;0&lt;/printToFile&gt;
  ...
</pre></td><tr></table>

<p>On UNIX platforms, the preferences file is named <i>.moodssrc</i> and is saved in the current user home directory, with write and read rights strictly restricted to the current user, as sensitive information, such as database passwords, can be stored in the preferences file.

<h6><a name="menus.view"></a>5.4.3. View</h6>

<h6><a name="menus.view.refresh"></a>5.4.3.1. Refresh</h6>

Immediately refreshes display of all loaded asynchronous modules.

<h6><a name="menus.view.polltime"></a>5.4.3.2. Poll Time</h6>

The <i>View</i> menu (may not exist, see below) contains the <i>Poll Time</i> entry which when selected launches the corresponding dialog box, as shown below:

<p><center><img src="/usr/share/doc/moodss-17.17/moodss2.gif" alt="poll time dialog box"></center>

<p>The user can select a new poll time among the module choices from a spin entry widget, or directly type in a new value, as long as it is not smaller than the module minimum poll time, in which case a warning message is displayed.

<p>When several modules are used, the minimum poll time is the greater of the minimum poll times of all modules. The default poll time (used when moodss is started) is the greater of the default poll times of all modules. The available choices in the poll time dialog box is the combination of all modules poll times.

<p>The <i>Poll time</i> menu entry is available only when needed, which is not the case if all the loaded modules are asynchronous. If this case, the <i>Options</i> menu itself is not displayed.
<br>This menu is only visible when not running in read-only mode (see <a href="#commandline">Command line</a>).

<h6><a name="menus.view.database.range"></a>5.4.3.3. Database range</h6>

Allows the specification of precise date and time limits for database views, loaded using the <a href="#menus.file.database.load">File Database Load menu</a>.

<p><center><img src="/usr/share/doc/moodss-17.17/dbrange.gif" alt="database range dialog box"></center>

<p>Note that once you have validated your choice (using either the <b>OK</b> button or the <b>Apply</b> button, the latter keeping the dialog box opened), the dialog box closes and all database related views are automatically refreshed (it is not necessary to manually use the <a href="#menus.view.refresh">refresh</a> view menu or button).
<br>Also note that the blue cursors in the database module instances viewer are updated in real-time as the values in the dialog box are changed.

<h6><a name="menus.view.trace"></a>5.4.3.4. Trace</h6>

Opens a separate window containing the <i>20</i> latest informational, error, ... messages (if any) internally generated by the loaded modules. This menu entry when selected again closes the window.

<p>A resident <a href="#trace">trace</a> module is actually used to fill the contents of that window, which does not prevent loading other instances of the <i>trace</i> module in the main window, as can be done with any other module.

<h6><a name="menus.view.toolbar"></a>5.4.3.5. Tool bar</h6>

Shows or hides the tool bar.

<h6><a name="menus.help"></a>5.4.4. Help</h6>

<h6><a name="menus.help.global"></a>5.4.4.1. Global</h6>

This menu launches an embedded HTML viewer with this very document minus the sections related to module development.

<h6><a name="menus.help.modules"></a>5.4.4.2. Modules</h6>

This menu features one sub menu per module, which when selected displays the module's help data.

<h6><a name="menus.help.about"></a>5.4.4.3. About</h6>

Displays version, author, extension authors, license and basic information about moodss.

<h5><a name="toolbar"></a>5.5. Tool bar</h5>

This common user interface part makes some menu actions direct by using buttons with embedded icons. Help is provided through widget tips (balloons).

<p><center><img src="/usr/share/doc/moodss-17.17/toolbar.gif" alt="tool bar in database recording mode"></center>

<p>The contents of the tool bar change depending on whether a module is loaded, a save file has been used, ... and always fit to the current context. The tool bar can be hidden or displayed at the user convenience using the <a href="#menus.view.toolbar">Tool bar</a> menu.

<h5><a name="canvasarea"></a>5.6. Canvas area</h5>

The largest part of the main window is the canvas area, used to display and manage data tables, viewers and icons. Its background color can be changed in <a href="#menus.edit.configuration">configuration</a> and <a href="#menus.edit.preferences">preferences</a>. An internal window manage handles all the operations within the canvas.

<p>All data viewers can be moved and resized thanks to handling areas in the data viewer borders. When moving the mouse pointer over these areas, the mouse cursor changes to indicate the possible action. Corner handles allow resizing in both X and Y axis. Handles in the middle of the sides allow resizing in either the X or Y axis direction. All other areas can be used for moving the data viewer as shown by the quadruple arrow cursor.
<br>Clicking on any part of the border changes the stacking order: the viewer being clicked on either goes below (possibly becomes hidden) the other viewers, or becomes fully visible (on top, possibly hiding other viewers). You can also circulate between tables and viewers by using the <i>Tab</i> (forward) and <i>Shift-Tab</i> (backward) keystrokes, which successively bring the next object to the top in the stacking order.

<p>When moving or resizing a table or a viewer, its window or its borders will snap, as if attracted by a magnet, when getting close to another window or the canvas borders. This make aligning a large number of windows convenient (<i>note: this feature was designed by somewhat copying the KDE window manager behavior</i>).
<br>When moving or resizing, the message area displays the current coordinates or size in real time as the mouse is being moved.

<p>Further description of this small window manager functionality is useless, as it behaves like a basic window manager (let me know if it does not).

<p>Module tables can be minimized by clicking on the down arrow button of the right side of a table title area. The resulting icons are arranged at the bottom left of the canvas area, from left to right. Icons can be moved simply by clicking and holding the left mouse button. Double clicking on an icon results in the corresponding table to become visible again at its original position.
<br>Once moved by the user, a table icon icon will remember its coordinates. That is if the table is restored then minimized again, the icon will be placed at its latest position.

<h5><a name="pagetabs"></a>5.7. Page tabs</h5>

If there are several pages displayed (see <a href="#menus.edit.newpage">New page</a> menu for creating pages), the pages tabs are visible near the bottom of the main window (by default, but the tabs can also be placed on top using the <a href="#preferences.application.pages">pages</a> section in preferences).

<p>A page tab label can be changed at any time while the application is running. <i>Double-click</i> or click with the <i>third</i> mouse button on the chosen tab, the text background then changes and the insertion cursor is displayed. Note that the whole text is initially selected to make it easy to replace the label by immediately typing. Once done, press the <b>Return</b> key to confirm or the <b>Escape</b> key to abort editing the tab label, in which case it returns to its previous value.

<p>Viewers and tables can easily be moved across pages by using the internal window manager. Move the table or viewer as you normally would but keep going into the destination page tab until the black drop border appears around the tab label, then drop. The table or viewer is placed at the upper left corner of the destination page.

<p><center><img src="/usr/share/doc/moodss-17.17/pagetabs.gif" alt="page tabs with thresholds summaries"></center>

<p>If a page contains any table or viewer containing data cells with active thresholds, then the page tab background takes the color of the most important threshold (according to its importance level). If there are several active thresholds of the same most important level, but with different colors, then the colors are shown in sequence, 1 per second, as the page tab background.
<br>Additionally, up to 3 of the most important threshold summaries are displayed in a widget tip (or balloon) when the mouse cursor lies over the page tab (see picture above).

<h5><a name="message"></a>5.8. Message</h5>

The message area header label also serves as a thresholds indicator, just like a page tab, but for all the thresholds activated in the application.

<p>The behavior is identical to a page tab, with the most important thresholds colors displayed in sequence if necessary, and a widget tip showing the most important thresholds summaries.

<h5><a name="messagesarea"></a>5.9. Message area</h5>

At the bottom of the main window, the message area is used to display various help and information strings for the user. For example, every time that a module is updated, when a menu entry is being activated, or to instruct the user on how to edit a page tab.

<p><center><img src="/usr/share/doc/moodss-17.17/messagesarea.gif" alt="messages area"></center>

<h5><a name="draganddrop"></a>5.10. Drag and drop</h5>

Drag and drop in moodss tries to behave as in popular GUIs. For example, to create a graphical plot, one must first select one or more data cells in a data table, hold down the first mouse button (the left one for a right handed user) while dragging over to the left-most icon below the menu bar (when dragging an object, as the mouse pointer passes over possible drop sites, they are highlighted with a thin black border for user feedback). Releasing the mouse button at this time results in the creation of a BLT graph viewer.

<p>Only valid drop sites for the data being dragged are highlighted when the mouse cursor passes over them, thus guaranteeing error free operations (if there are no bugs, that is :).

<p>In summary, data cells can be dragged from any table or any viewer into any viewer drop site icon, any viewer or the eraser.

<h6><a name="dropsites"></a>5.10.1. Drop sites</h6>

All icons right below the menu bar are valid drop sites for data cells (several may be dropped at the same time). From left to right:<ul>
  <li>graph viewer with one or more data curves created at once
  <li>stacked graph viewer with one or more data filled curves created at once
  <li>side by side bar chart with one or more data bars created at once
  <li>stacked bar chart with one or more data bars created at once
  <li>2D pie chart with one or more data slices created at once
  <li>3D pie chart with one or more data slices created at once
  <li>values table with one or more data rows created at once
  <li>statistics table with one or more data rows created at once
  <li>free text with one or more labeled data cell windows created at once
  <li>thresholds with one or more entries created at once
  <li>object eraser with one or more data viewer elements deleted at once
</ul>

<p>For example, a graph viewer with 1 curve is created by dropping 1 data cell into the graph viewer icon.

<p>Once a viewer exists, it also acts as a drop site for data cells, which may be dragged from any table or other viewers. Dropping one or more cells directly in the viewer results in corresponding lines, bars, slices or rows being created and automatically updated. Each new graphical element is assigned a new and different color.

<p>You may delete one or more viewer elements (graph lines, bar chart bars, pie charts slices, statistics or values table rows or free text cell window) from a viewer by selecting them (using the first mouse button) through their labels. Several elements can be selected by depressing the control key as the first mouse button is pressed. The selection can also be extended by depressing the shift key along with the first mouse button. The pie slices can also be directly selected by clicking on the slices themselves.
<br>Then dragging from the viewer to the eraser drop site (the pencil eraser) on the upper right side of the main window and releasing the first mouse button result in the corresponding viewer elements to be destroyed. When there are no remaining elements, the viewer itself (graph, bar chart, pie, values or statistics table) can be destroyed by dropping it into the eraser site. The free text viewer can only be deleted this way when completely emptied of any text and data cell window.

<p>Any viewer can be deleted in one shot by dropping from the eraser icon into it.
<br>Yet another way is to move the viewer (as usual, using the internal window manager handles) into the eraser.

<p>Any viewer also acts as a drop site for viewer type data, which allows viewer mutation by just dropping from the new viewer type icon into the existing viewer. It is much quicker than destroying the existing viewer and create a new one of the new type, while remembering which data cells were monitored by the viewer of the old type.
<br>When mutating, if some cells in the current viewer no longer exist (they may belong to a disappeared statistics table), they are not made a part of the new viewer, and a warning message is flashed to the user in the message area.

<p>A page tab is a drop site for any table or viewer, which allows transferring them between pages. Proceed by moving the table or viewer (as usual, using the internal window manager handles) into another page tab (wait until you see the drop black outline around the tab label to release the mouse button). The viewer can then be found in the upper left corner of the target page.

<h6><a name="dragsites"></a>5.10.2. Drag sites</h6>

A table is obviously a drag site. One or more cells can be dragged at once after selection, using the traditional single/shift/control mouse click technique.

<p>Any viewer is also a drag site. It requires selecting one or more viewer elements before initiating the drag operation from any selected element in the viewer. If there are no selected elements, dragging is impossible: the mouse cursor is not changed into the drag circular cursor.

<p>If a viewer contains no elements, then the viewer itself can be dragged and dropped into the eraser.

<p>All viewer icons (below the menu bar) are drag sites for viewer type data, which allows quick viewer mutation (see mechanism description in <a href="#dropsites">Drop sites</a>).

<p>The eraser icon is also a drag site of the killing action type, which allows viewer destruction in one shot.

<p>A viewer or a table is also a drag site when being moved via its window manager handles:<ul>
  <li>a viewer can be moved into the eraser for deletion
  <li>a table or a viewer can be moved into a page tab text area for transfer to another page
</ul>

<h4><a name="commandline"></a>6. Command line</h4>

<h5><a name="mainarguments"></a>6.1. Main arguments</h5>

Launching moodss is very simple:

<table bgcolor="#DFDFDF" width="100%"><tr><td><pre>
    $ moodss
</pre></td><tr></table>

<p>or

<table bgcolor="#DFDFDF" width="100%"><tr><td><pre>
    $ wish moodss
</pre></td><tr></table>

<p>if the Tcl/Tk wish interpreter is not found in your PATH. You can then dynamically load modules from the File menu.

<p>You can also just pass one or more data module names as parameters, as in:

<table bgcolor="#DFDFDF" width="100%"><tr><td><pre>
    $ wish moodss random
</pre></td><tr></table>

<p>or, for 2 modules at once:

<table bgcolor="#DFDFDF" width="100%"><tr><td><pre>
    $ wish moodss ps cpustats
</pre></td><tr></table>

<p>You can specify the same module more than once and with different arguments in the command line:

<table bgcolor="#DFDFDF" width="100%"><tr><td><pre>
    $ wish moodss ps -r host.domain ps -r otherhost.domain
</pre></td><tr></table>

<p>When several modules of the same type are passed as argument, the initial data tables feature the module name followed by a number as title. For example <i>"ps&lt;2>"</i>. If the module provides an identifier string, that text will be used instead, as in <i>"ps(host.domain)"</i>. Data cell labels include the module identifier or numbered module name as well, for proper identification.

<p>You may optionally specify a poll time in seconds using:

<table bgcolor="#DFDFDF" width="100%"><tr><td><pre>
    $ wish moodss -p 25 random
</pre></td><tr></table>

<p>Note that when all the specified modules are asynchronous, the poll time option specifies the preferred interval for graph viewers.

<p>You can also specify pages tab labels as a list, using:

<table bgcolor="#DFDFDF" width="100%"><tr><td><pre>
    $ wish moodss --tabs '"Servers 1" "Servers 2" Workstations'
</pre></td><tr></table>

<p>which would create 3 tabs. Note that it is not required to specify tab labels when loading from a save file, as they are saved along. Once created in this way, tabs can be edited in place (see <a href="#userinterface">user interface</a>).

<p>Once saved through the File Save menus (for example in save.moo), the configuration can be retrieved using:

<table bgcolor="#DFDFDF" width="100%"><tr><td><pre>
    $ wish moodss -f save.moo
</pre></td><tr></table>

<p>which would result in the same modules being loaded, the same viewers displayed at the same positions and sizes, the same poll time being used, as well at the same application window size. New modules data displays can be added at any latter time to existing dashboards by specifying modules on the command line after the -f (--file) switch / value pair.

<p>Command line options include:<ul>
  <li><b>--debug</b>: set verbose reporting when module errors occur
  <li><b>-f</b> (or <b>--file</b>): specify a configuration file name
  <li><b>-h</b> (or <b>--help</b>): display some help text and exit
  <li><b>-geometry</b>: set the initial geometry of the main window (a la X window)
  <li><b>-p</b> (or <b>--poll-time</b>): specify a poll time in seconds
  <li><b>-r</b> (or <b>--read-only</b>): disable viewer creation, editing, ...
  <li><b>-S</b> (or <b>--static</b>): disable internal window manager sizing and moving
  <li><b>--tabs</b>: specify notebook pages tabs labels
  <li><b>--show-modules</b>: discover valid moodss modules, show their directory location(s) and exit
  <li><b>--version</b>: output version information and exit
</ul>

<p>Moodss command line options must appear before any module name appears on the command line, so as not to interfere with the module options.

<p>In debug mode, when errors occur within the module namespace body or initialize procedure, the error message (either in text output when loading the module from the command line, or in a message window when dynamically loading the module) is followed by a Tcl stack trace of what was in progress when the error occurred (see the Tcl <i>error</i> manual page for further information).

<h5><a name="modulearguments"></a>6.2. Module arguments</h5>

Module themselves can take options (if programmed to do so, see <a href="#initialization">module initialization</a>), through command line arguments placed right after the module name and before the next module name, if any.

<p>For example, the following command:

<table bgcolor="#DFDFDF" width="100%"><tr><td><pre>
    $ moodss -p 15 random --asynchronous arp --remote jdoe@foo.bar --numeric route --numeric
</pre></td><tr></table>

<p>causes the <i>random</i> module to update asynchronously, the <i>arp</i> module to collect data from the <i>foo.bar</i> host under the <i>jdoe</i> login name and not attempt to lookup symbolic names for hosts, with the last module <i>route</i> doing the same.

<p>Note the setting the application poll time to 15 seconds does not interfere with the module options.

<p>The moodss core checks the validity of module options according to the information provided by the module programmer. Any invalid option / value combination for the module is detected, reported on the standard error channel before the application exits.

<p>Finally, it is always possible to determine the valid options for a module, using the following command:

<table bgcolor="#DFDFDF" width="100%"><tr><td><pre>
    $ moodss module --help
</pre></td><tr></table>


<h4><a name="core.configuration"></a>7. Configuration</h4>

All configuration parameters can be set using the following interface:

<p><center><img src="/usr/share/doc/moodss-17.17/moodss6.gif" alt="configuration dialog box"></center>

<p>The Configuration dialog box allows the user to change global settings for the current view (also called a dashboard). This data is stored along when saving the configuration to a file (see <a href="#menus.file.save">Save</a> menu).

<p>Changing configuration choices do not affect the <a href="#core.preferences">Preferences</a> choices, which are used as initial values the first time the user modifies the configuration. Configuration settings have a higher priority than preferences settings, but are lost when not filed.

<p>Configuration entry is done through pages organized in a browsable hierarchical tree, always visible on the left side of the configuration dialog box (see picture above).

<p>After selection of the category from the tree on the left, a related dialog interface appears, which may or may not allow immediately applying new data values.
<br>Clicking on the OK button results in the current configuration data to be saved in memory. It will be stored in the save file when requested (see File <a href="#menus.file.save">Save</a> and <a href="#menus.file.saveas">Save as</a> menus).

<p>Specific help can always be accessed by clicking on the bottom <b>Help</b> button when in a configuration page.

<h5><a name="configuration.application"></a>7.1. Application</h5>

The canvas is the data viewers background area, and its configuration (size, color, ...) can be changed as described below.

<h5><a name="configuration.application.size"></a>7.1.1. Size</a></h5>

The canvas width and height can be changed so that all the different tables and viewers that the dashboard comprises can fit nicely within the viewing space.
<br>It is also possible to make the canvas size automatically scale as the main window is resized by the user. In this case, scrollbars are never displayed. Note that automatic scaling means that the width and height are set to <i>0</i>, so you may force automatic scaling in one direction only by setting its size to <i>0</i>.

<p>The default is the current screen size.

<p>The size is immediately updated when clicking on the <b>Apply</b> button.

<h5><a name="configuration.application.colors"></a>7.1.2. Colors</a></h5>

The canvas color can be changed for your viewing pleasure...

<p>The color is immediately updated when clicking on the <b>Apply</b> button.

<h5><a name="configuration.viewers"></a></a>7.2. Viewers</h5>

The viewers are used for viewing table data, and their configuration (colors, ...) can be changed as described below.

<h5><a name="configuration.viewers.colors"></a>7.2.1. Colors</a></h5>

These are the colors of viewer elements. For each viewer that needs different colors for displaying data cell elements (such as graphs, pie charts, ...), each new element uses the next color in the sequence (wraps around if necessary).

<p><i>Advice</i>: adjacent colors should be very different, colors should be visible on a black background.

<p><i>Note</i>: in a future version, creating, deleting and moving colors in the sequence will be possible.

<h5><a name="configuration.viewers.graphs"></a>7.2.2. Graphs</a></h5>

The number of samples (on the X axis) can be changed for data graph viewers. The more samples, the wider the X axis and thus the longer the visible data time span.

<p>By default, the Y axis scales automatically with its minimum and maximum values set to those of all plotted data points, for maximum precision. Optionally, a value of <b>0</b> can be fixed for the Y axis minimum.

<p>It is also possible to set the angle of the X axis (date and time) labels (from the slanted 45 degrees to the default vertical 90 degrees).

<p>These settings can be immediately applied to existing graphs by clicking the <b>Apply</b> button.

<h5><a name="configuration.viewers.pies"></a>7.2.3. Pies</a></h5>

The labeler type for data pie viewers can be changed as follows:<ul>
  <li>current value labels can be displayed next to corresponding slices (<b>peripheral</b> style)
  <li>or next to the corresponding text labels (<b>box</b> style)
</ul>

<p>The selected type will not be used for existing pies but for newly created ones.

<h5><a name="configuration.viewers.tables"></a>7.2.4. Tables</a></h5>

In database history mode, set the maximum number of displayed rows (see <a href="#viewers.tables">tables</a>).

<h5><a name="configuration.viewers.cells"></a>7.2.5. Cells</a></h5>

One can choose whether module names or identifiers are displayed in cell labels in viewers (such as graphs, pies, tables, ...).
<br>For example, when there is only one module loaded, or several modules but with specific and easily recognizable data cell labels, it may not be necessary for data cell labels to be prefixed with the module name in viewers.

<h4><a name="core.preferences"></a>8. Preferences</h4>

The preferences dialog box is used for application-wide settings.<br>
It is very similar to the <a href="#core.configuration">configuration</a> dialog box, except that it also includes canvas printing and email servers settings.
<br>It allows the user to change application wide settings, saved in a global file (known as an <i>rc</i> file to UNIX people), used for initialization when the application is started. Since this file is stored in the user home directory (on a UNIX system), it provides a way for a user to customize the look, behavior, ... of the moodss application in a permanent manner.

<p>Preferences choices, when applied (either by choosing Apply or OK) also affect <a href="#core.configuration">configuration</a> settings.

<p>On UNIX systems, preferences data is saved in each user home directory under the <i>rc</i> file named <i>.moodssrc</i>.<br>
On Windows, data is saved in <i>C:\.moodssrc</i> (by default, but depends on the <i>HOME</i> variable).

<p>After selection of the category from the tree on the left, a related dialog interface appears.
<br>Help is provided for each interface, which may or may not allow immediately applying new data values.
<br>Clicking on the <b>OK</b> button results in the preferences data to be written to the <i>rc</i> file.

<h5><a name="preferences.application"></a>8.1. Application</h5>

<h5><a name="preferences.application.fonts"></a>8.1.1. Fonts</a></h5>

You can choose the font family and its size, to be used globally in the user interface, for menus, viewers, ... Every time another family or size is selected, the text area below the drop down menus is updated using the new font, so that the user can evaluate the change.

<p><i><b>Note</b>: the application needs to be restarted for changes to take effect.</i>

<h5><a name="preferences.application.printing"></a>8.1.2. Printing</a></h5>

The canvas area can be printed in the Postscript data format.<br>
The default behavior when printing can be set to either a printer or a file, but can always be overridden in the print dialog box launched when actually printing.
<br>Various parameters, such as orientation, palette and paper size can be set.

<p>The print command typically reads the Postscript data from its standard input and redirects it to the specified printer (for example, on UNIX, 'lpr -Pacme' will print the canvas area on the "acme" printer.
<br>By default, the command is set to 'lpr -P%P', which by including the <em>%P</em> generic printer name tag allows the user to pick the printer from a list (drawn from the <i>/etc/printcap</i> database) at printing time.

<p>When printing to a file, you may choose its default location and name with the file browser. Note that it can be overridden in the print dialog box launched when actually printing.

<h5><a name="preferences.application.pages"></a>8.1.3. Pages</a></h5>

When pages are used (see <a href="#menus.edit.newpage">New page</a> menu), the user can choose whether the pages tabs are positioned on the <i>top</i> or the <i>bottom</i> side of the pages.

<h5><a name="preferences.application.database"></a>8.1.4. Database</h5>

If you want the moodss application or the moomps daemon to store data cell values in a history database, set the following options:
<!-- the following list is the same as in the database HTML documentation -->
<ul>
  <li><b>file</b>: the single file holding complete data accessed by the SQLite library (that is the only parameter needed by the SQLite library).
  <li><b>dsn</b>: Data Source Name, if specified, means that database access is done via ODBC, which requires the <i>tclodbc</i> package to be installed. If not specified, native MySQL database access is used, which requires the <i>mysqltcl</i> package library to be installed.
  <li><b>host</b>: the database server host name, or IP address <i>(not allowed in ODBC mode)</i>. Use <i>localhost</i> for socket based access (also see MySQL documentation).
  <li><b>password</b>: the password used to connect to the database (also see <i>user</i>). <i><b>Note</b>: it is stored in clear, so only allowing access to the moomps <b>preferences</b> file from the <b>root</b> account is highly recommended.</i>
  <li><b>port</b>: the port number corresponding to the database service <i>(not allowed in ODBC mode)</i>.
  <li><b>user</b>: the user name used to connect to the database (also see <i>password</i>).
  <li><b>database</b>: the MySQL database name for the MySQL native driver <i>(<b>moodss</b> by default, not allowed in ODBC mode)</i>.
  <li><b>SQL trace</b>: when set, all SQL statements and queries are either printed on the terminal where moodss was launched, or in the system log, for the moomps daemon (<i>off by default, available on UNIX platforms only</i>).
</ul>

<p>Note that no changes are allowed if there is a current connection to the database (storing some data cells history). Also the <b>moomps</b> daemon, if running, must be restarted to take any change into account (also see its <a href="#preferences.moomps">configuration</a>).

<h5><a name="preferences.application.trace"></a>8.1.5. Trace</h5>

The number of rows in the <a href="#menus.view.trace">trace</a> window can be set (it is <i>20</i> by default).
<br><i>Note</i>: the new value will not be taken into account immediately but the next time the application is started.

<h5><a name="preferences.thresholds"></a>8.2. Thresholds</h5>

<h5><a name="preferences.thresholds.email"></a>8.2.1. Email</h5>

When a threshold event occurs, an email alert message can be sent (see <a href="#menus.edit.thresholds">thresholds</a>).

<p>Proper identification is required so that the originator of the message (the <i>From</i> address field in an email message) is known. Use your own email address or another email address (such as <i>moodss@your.domain.com</i>) that you control.
<br>In any case, the <b>From address</b> field must contain a valid email address.
<br>Your user name is used by default.
<br>When closing the dialog box or moving to another section, the syntax of the email address is checked and errors, if any, reported in a message box.

<p>Sending email requires at least one <b>Outgoing mail SMTP server</b>. Input the one that you use for sending your emails (check your browser or email software current configuration), or any other valid SMTP address (consult your system administrator in case of doubt).
<br>You may enter additional servers that will be used as backups of the main server in case it fails. Keep pressing the &lt;Enter&gt; key to append servers to the list. To remove a server from the list, simply empty its list cell using the usual editing keys.<br>
The local host (<i>127.0.0.1</i> address) is used by default as the main SMTP server.

<p>The mail message is built with a default <b>subject</b> and <b>body</b>, used for all thresholds for which the message has not been customized (see <a href="#menus.edit.thresholds">thresholds</a> dialog box). The subject line and body text can include % substitutions, as described in the thresholds <a href="#menus.edit.thresholds.script">script</a> section.
<br>Depressing the <b>default</b> button restores the subject and boby to their application hard coded default.

<h5><a name="preferences.thresholds.trace"></a>8.2.2. Trace</h5>

When a threshold condition occurs, a summary is sent to the trace module (visible via its window if it is displayed or by its table(s) if it is loaded as a module). This is the behavior by default, which can be turned off from this preferences page.

<h5><a name="preferences.moomps"></a>8.3. Daemon (moomps)</h5>

<i>(only available on UNIX platforms)</i>

<p>The moomps daemon preferences file location can be changed from the <i>/etc/moomps/rc</i> default value. You must have write rights to the chosen file and its directory, as determined for the current user (generally <i>root</i> as traditionally used for configuring daemons). Error messages are appropriately displayed when this is not the case.

<p>When the preferences are validated, all moomps relevant data will be written to the chosen file in XML format. You may enter no file name by clearing the textual entry space.

<p>The daemon preferences file is saved with write and read rights strictly restricted to the current user, as sensitive information, such as database passwords, can be stored in it.

<h3><a name="faq"></a>9. Frequently Asked Questions</h3>

<h4>Q: How do I make the moomps daemon store some data cells history in the database?</h4>

<b>A</b>: Here is the road map from start to finish:<ul>
  <li>allow access to the database by properly filling the preferences <a href="#preferences.database">database</a> section (note that as a database user, you must have write access to the moodss database (contact your database administrator if in doubt)).
  <li>try your configuration by using the file database <a href="#menus.file.database.load">load</a> menu: that should give you no errors provided the <i>moodss</i> database exists and your database user is valid, else contact your database administrator and restart the procedure until it works.
  <li>in the preferences <a href="#preferences.moomps">daemon (moomps)</a> section, choose the configuration file that the moomps daemon will use (of course you must have write access to that file) and validate: the database configuration is then saved for moomps to use when saving data cells histories (all see the moomps <a href="moomps.htm">documentation</a>).
  <li>use an existing configuration (save) file, or load modules, ..., use the edit <a href="#menus.edit.database">database</a> menu and drop data cells in the dialog box that opens.
  <li>save the configuration (file <a href="#menus.file.save">save</a> menu) in the moomps directory for configuration files (<i>/etc/moomps/</i> by default, of course you must have write access to it).
  <li>start or restart the moomps daemon (you may also dynamically modify configuration files already loaded by a running moomps daemon: the modifications will be taken into account shortly thereafter).
  <li>after a while, check that the data is actually stored from the file database <a href="#menus.file.database.load">load</a> menu.
</ul>

<h4>Q: Why some tables cannot be erased?</h4>

<b>A</b>: Those tables hold the module data and therefore can only be erased by unloading the corresponding module. They are easily recognizable since they are the only ones with a window bar including the module name.

<h4>Q: How do I know what the module does when loading?</h4>

<b>A</b>: What the module does when loading is really dependent on the module implementation itself. It should be described in the module documentation (accessible through the <i>Help</i> menu). A message appears in the moodss main window message area when each module is loading. Note that this message can be fugitive even if the module initialization takes a while and the module does it in the background (as it should so that other modules get a chance to also initialize).
<br>If there are any errors, they will be reported in the message area. I suggest opening the <a href="#menus.view.trace">trace</a> window or loading the <i>trace</i> module is you want to precisely keep track of those errors.

<h4>Q: How do I delete a viewer?</h4>

<b>A</b>: There are several ways:<ul>
  <li>when empty of monitored cells, drag and drop into the eraser
  <li>drag the eraser and drop it into the viewer, even if not empty
  <li>move the viewer (as usual, using the internal window manager handles) into the eraser
</ul>

<h4>Q: How do I transfer a table or a viewer to another page?</h4>

<b>A</b>: Move it (as usual, using the internal window manager handles) into another page tab (wait until you see the drop black outline around the tab label to release the mouse button). The viewer can then be found in the upper left corner of the target page.

<h4>Q: When reloading a module fails from the File/Modules/Manage dialog box, the module disappears from the list and all its options values are lost. Why?</h4>

<b>A</b>: the internal implementation requires that reloading a module be done in 2 steps: unloading the existing module then loading it using the new options values. Those are not lost however (starting from moodss 17.6): they are reused when trying to load a new instance of the module from the File/Modules/Load dialog box.

<h4>Q: What happens if files are changed, deleted, added, ... in the directory that the moomps daemon is using for its configuration files?</h4>

<b>A</b>: If a configuration file that is monitored by moomps (see configuration files and directory parameters in the <a href="#usage">usage</a> section), is:<ul>
  <li><b>changed</b>: it is reloaded as soon as the daemon becomes aware of its recent modification time (depending on the monitoring poll time of the configuration files, as described in the <a href="#usage">usage</a> section).
  <li><b>deleted</b>: nothing happens (the moomps daemon does not unload the file, it needs to be restarted to take the change into account).
  <li><b>added</b> to the monitored directories: nothing happens for security reasons (the moomps daemon does not load the file, it needs to be restarted to take the change into account).
</ul>

<h4>Q: What happens when, in the moodss GUI edit database dialog box, some data cells state is changed, and the moomps daemon is running?</h4>

<b>A</b>: Once the states are changed, the edit database dialog closed and the configuration file saved using the File/Save menu, the moomps daemon sees that the file has been updated and reloads it, provided of course that the file is part of the configuration files that the daemon is monitoring (see configuration files and directory parameters in the <a href="#usage">usage</a> section).
<br>Thus such changes are taken into account quickly (depending of course on the monitoring poll time of the configuration files, as described in the <a href="#usage">usage</a> section).

<h3><a name="future"></a>10. Future developments</h3>

Please look at the TODO file (at least present in the source distribution).

<p>I welcome any suggestion for new features that you may need in your specific use of moodss.

<h3><a name="misc"></a>11. Miscellaneous information</h3>

For downloading Tcl software (such as stooop, scwoop, tkpiechart, ...), many Red Hat rpm packages, visit my home page at <a href="http://jfontain.free.fr/">http://jfontain.free.fr/</a>.

<p>You may also find more information, such as reviews, links, examples, ... in the moodss (<a href="http://jfontain.free.fr/moodss/">http://jfontain.free.fr/moodss/</a>) and MySQL (<a href="http://jfontain.free.fr/mysql/">http://jfontain.free.fr/mysql/</a>) pages.

<p>Please report bugs and comments to <a href="news:comp.lang.tcl">comp.lang.tcl</a> or <a href="mailto:jfontain@free.fr">jfontain@free.fr</a>.

</body>
</html>

}
